#!/usr/bin/python
import os
from mininet.net import Mininet
from mininet.node import Controller, RemoteController, OVSController
from mininet.node import CPULimitedHost, Host, Node
from mininet.node import OVSKernelSwitch, UserSwitch
from mininet.nodelib import LinuxBridge
from mininet.node import IVSSwitch
from mininet.cli import CLI
from mininet.log import setLogLevel, info
from mininet.link import TCLink
from mininet.link import  Intf
from subprocess import call
import time

execfile("./settings")

def myNetwork():

    info( '********* Project 1Task 1  **********************\n' )
    net = Mininet( topo=None, build=False, ipBase='10.0.0.0/8', link=TCLink)

    info( '*** Adding controller\n' )
    c0=net.addController(name='c0', controller=OVSController, protocol='tcp', port=6633)

    info( '*** Add switches\n')
    s0 = net.addSwitch('s0', cls=OVSKernelSwitch, failMode='standalone')
    s1 = net.addSwitch('s1', cls=OVSKernelSwitch, failMode='standalone')
    

    info( '*** Add hosts\n')
    hTEM = net.addHost('hTEM', ip='10.0.0.1/8')
    hTES = net.addHost('hTES', ip='10.0.0.2/8')
    

    info( '*** Add links between hosts and switches\n')
   
    net.addLink(hTEM, hTES, bw=link_bandwidth, delay=link_delay, use_htb=True)

    info( '*** Starting network\n')
    net.build()

    info( '*** Starting controllers\n')
    c0.start()

    info( '*** Starting switches\n')
    net.get('s0').start([c0])
    

    net.start()


    info( '*** Waiting for STP to converge \n')
    #time.sleep(1)


    net.pingAll()
    #CLI( net )
    #net.stop()

    return(net)


def myPerformQoCTest(net):
    print "*** QoC Test Initiated ..."

    # Run Controller in Master hTEM

    net.get('hTES').cmd("sudo nohup python load.py &")
    net.get('hTEM').cmd("sudo nohup python controller.py")
    #net.get('hTES').cmd("sudo python load.py")

    time.sleep(5)
    #net.get('hTEM').cmd("touch ./results/abc")
    print "*** QoC Test Completed ..."
    # Run Load in Slave hTES

if __name__ == '__main__':
    
    t = time.localtime()
    current_time = time.strftime("%H:%M:%S", t)
    print current_time
    
    os.system("sudo mn -c")

    ## clean results/StepAnalysis/ folder
    os.system("sudo rm ./results/StepAnalysis/*")

    setLogLevel( 'info' )

    # Simulate Network Topology
    #net = tempNetwork()
    net = myNetwork()
  
    # Conduct QoC Test
    myPerformQoCTest(net) 

    # Open Command Line Interface
    #CLI( net )

    t = time.localtime()
    current_time = time.strftime("%H:%M:%S", t)
    print current_time

    exit()
    
    #net.stop()
    #myNetwork()
